Timer = {}

local timers = {}

function Timer.new(time, repeatCount, callbackFunc, ...)
	local t = {}

	t.time = time
	t.timeLeft = time
	t.repeatCount = repeatCount
	t.func = callbackFunc
	t.params = {...}

	function t:update(dt)
		self.timeLeft = self.timeLeft - dt

		if self.timeLeft <= 0 then
			self.func(unpack(t.params))
			print("LAL")

			-- Repeat several times.
			if self.repeatCount > 0 then
				self.repeatCount = self.repeatCount - 1
				self:restart()
			-- Repeat forever.
			elseif self.repeatCount == -1 then
				self:restart()
			-- Stop.
			else
				self:stop()
			end
		end
	end

	function t:restart()
		self.timeLeft = self.time
	end

	function t:stop()
		self.removeMe = true
	end

	table.insert(timers, t)
end

function Timer.update(dt)
	for k, v in pairs(timers) do
		if v.removeMe then
			timers[k] = nil
		else
			v:update(dt)
		end
	end
end



return Timer